'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FloatingActionButton = require('material-ui/FloatingActionButton');

var _FloatingActionButton2 = _interopRequireDefault(_FloatingActionButton);

var _semanticUiReact = require('semantic-ui-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Item = function Item(_ref) {
	var children = _ref.children,
	    className = _ref.className,
	    mini = _ref.mini,
	    color = _ref.color,
	    light = _ref.light,
	    bordered = _ref.bordered,
	    label = _ref.label,
	    Component = _ref.as,
	    props = _objectWithoutProperties(_ref, ['children', 'className', 'mini', 'color', 'light', 'bordered', 'label', 'as']);

	return _react2.default.createElement(
		Component,
		_extends({ className: (0, _classnames2.default)('et-item', 'animated', {
				'et-mini': mini,
				'et-light': light,
				'et-bordered': bordered
			}, className) }, props),
		label && _react2.default.createElement(
			_semanticUiReact.Label,
			{ color: 'black', className: 'et-label' },
			label
		),
		_react2.default.createElement(
			_FloatingActionButton2.default,
			{ mini: mini, backgroundColor: color },
			children
		)
	);
};

Item.displayName = 'Item';
Item.defaultProps = {
	as: 'div'
};

exports.default = Item;