'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAutobind = require('react-autobind');

var _reactAutobind2 = _interopRequireDefault(_reactAutobind);

var _reactTimeout = require('react-timeout');

var _reactTimeout2 = _interopRequireDefault(_reactTimeout);

var _Item = require('./components/Item');

var _Item2 = _interopRequireDefault(_Item);

var _Main = require('./components/Main');

var _Main2 = _interopRequireDefault(_Main);

require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Components


// Styles


var Actions = function (_React$Component) {
    _inherits(Actions, _React$Component);

    function Actions(props) {
        _classCallCheck(this, Actions);

        var _this = _possibleConstructorReturn(this, (Actions.__proto__ || Object.getPrototypeOf(Actions)).call(this));

        (0, _reactAutobind2.default)(_this);

        _this.state = {
            timeout: null,
            hide: true
        };

        if (props.open === null) {
            if (props.on === 'click') {
                _this.onEvent = {
                    onClick: _this.handleClick
                };
            } else if (props.on === 'hover') {
                _this.onEvent = {
                    onMouseEnter: _this.handleUnHide,
                    onMouseLeave: _this.handleHide
                };
            }
        } else {
            _this.onEvent = {};
        }
        return _this;
    }

    _createClass(Actions, [{
        key: 'handleUnHide',
        value: function handleUnHide() {
            this.props.clearTimeout(this.state.timeout);
            this.setState({
                timeout: null,
                hide: false
            });
        }
    }, {
        key: 'handleHide',
        value: function handleHide() {
            var _this2 = this;

            this.setState({
                timeout: this.props.setTimeout(function () {
                    _this2.setState({ hide: true });
                }, 300)
            });
        }
    }, {
        key: 'handleClick',
        value: function handleClick() {
            if (this.state.hide) this.handleUnHide();else this.handleHide();
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.open !== null) {
                if (nextProps.open === true) this.handleUnHide();else this.handleHide();
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var Component = this.props.as;

            return _react2.default.createElement(
                Component,
                _extends({}, this.onEvent, {
                    className: (0, _classnames2.default)('et-module-actions', this.props.className, {
                        'et-left': this.props.left,
                        'et-top': this.props.top,
                        'et-hide': this.state.hide,
                        'et-click': this.props.on === 'click' || this.props.open !== null,
                        'et-hiding': this.state.timeout !== null
                    }) }),
                this.props.children
            );
        }
    }]);

    return Actions;
}(_react2.default.Component);

Actions.displayName = 'Actions';


Actions.Item = _Item2.default;
Actions.Main = _Main2.default;
Actions.defaultProps = {
    open: null,
    left: false,
    top: false,
    on: 'hover',
    as: 'div'
};

exports.default = (0, _reactTimeout2.default)(Actions);