'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsCssTransitionGroup = require('react-addons-css-transition-group');

var _reactAddonsCssTransitionGroup2 = _interopRequireDefault(_reactAddonsCssTransitionGroup);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Animate = function Animate(_ref) {
	var as = _ref.as,
	    children = _ref.children,
	    animate = _ref.animate,
	    transition = _ref.transition,
	    transitionTimeout = _ref.transitionTimeout,
	    enter = _ref.enter,
	    transitionEnter = _ref.transitionEnter,
	    transitionEnterTimeout = _ref.transitionEnterTimeout,
	    leave = _ref.leave,
	    transitionLeave = _ref.transitionLeave,
	    transitionLeaveTimeout = _ref.transitionLeaveTimeout,
	    rest = _objectWithoutProperties(_ref, ['as', 'children', 'animate', 'transition', 'transitionTimeout', 'enter', 'transitionEnter', 'transitionEnterTimeout', 'leave', 'transitionLeave', 'transitionLeaveTimeout']);

	if (transition !== null) {
		transitionEnter = transition;
		transitionLeave = transition;
	}

	if (transitionTimeout !== null) {
		transitionEnterTimeout = transitionTimeout;
		transitionLeaveTimeout = transitionTimeout;
	}

	if (animate !== null) {
		enter = animate.replace('InOut', 'In').replace('OutIn', 'Out').replace('DownUp', 'Down').replace('UpDown', 'Up');
		leave = animate.replace('InOut', 'Out').replace('OutIn', 'In').replace('DownUp', 'Up').replace('UpDown', 'Down');
	}

	var transitionName = {
		enter: _styles2.default['_' + transitionEnterTimeout],
		leave: _styles2.default['_' + transitionLeaveTimeout],
		enterActive: enter,
		leaveActive: leave
	};

	return _react2.default.createElement(
		_reactAddonsCssTransitionGroup2.default,
		_extends({
			component: as,
			transitionName: transitionName,

			transitionEnter: transitionEnter,
			transitionEnterTimeout: transitionEnterTimeout,

			transitionLeave: transitionLeave,
			transitionLeaveTimeout: transitionLeaveTimeout

		}, rest),
		children
	);
};

Animate.displayName = 'Animate';
Animate.defaultProps = {
	as: 'span',
	animate: null,
	transition: null,
	transitionTimeout: null,
	enter: 'fadeIn',
	transitionEnter: true,
	transitionEnterTimeout: 300,
	leave: 'fadeOut',
	transitionLeave: true,
	transitionLeaveTimeout: 300
};

Animate.propTypes = {
	enter: _propTypes2.default.string,
	leave: _propTypes2.default.string,
	duration: _propTypes2.default.number,
	children: _propTypes2.default.any
};

exports.default = Animate;