'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _isoScroll = require('iso-scroll');

var _isoScroll2 = _interopRequireDefault(_isoScroll);

var _semanticUiReact = require('semantic-ui-react');

require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Cards = function Cards(_ref) {
    var count = _ref.count,
        cards = _ref.cards,
        title = _ref.title,
        icon = _ref.icon,
        children = _ref.children,
        empty = _ref.empty,
        showMore = _ref.showMore,
        onShowMore = _ref.onShowMore;
    return _react2.default.createElement(
        _semanticUiReact.Segment,
        { className: 'et-module-cards' },
        _react2.default.createElement(
            _semanticUiReact.Label,
            { attached: 'top' },
            icon && _react2.default.createElement(_semanticUiReact.Icon, { name: icon, className: 'et-icon' }),
            title,
            _react2.default.createElement(
                'a',
                { onClick: onShowMore, className: 'et-show-more' },
                'Show ',
                showMore ? 'Less' : 'More'
            ),
            count && _react2.default.createElement(
                _semanticUiReact.Label,
                { color: 'red', floating: true, circular: true },
                count
            )
        ),
        _react2.default.createElement(
            _isoScroll2.default,
            null,
            _react2.default.Children.count(children) ? _react2.default.createElement(
                'div',
                { className: 'et-container' },
                _react2.default.createElement(
                    _semanticUiReact.Card.Group,
                    {
                        className: (0, _classnames2.default)('et-group', { 'et-full': showMore }),
                        itemsPerRow: cards,
                        stackable: true,
                        doubling: true },
                    children
                )
            ) : _react2.default.createElement(
                _semanticUiReact.Header,
                { textAlign: 'center', size: 'large' },
                empty
            )
        )
    );
};

Cards.displayName = 'Cards';
/**
 * SIDE SCROLLING
 * -----------------------------------------------------
    <div className='et-container'>
        <div className='et-nav-left'>
            <Button circular icon>
                <Icon name='angle left' size='large'/>
            </Button>
        </div>
        <Card.Group
        className='et-group'
        itemsPerRow={ cards }
        stackable>{ children }</Card.Group>
        <div className='et-nav-right'>
            <Button circular icon>
                <Icon name='angle right' size='large' />
            </Button>
        </div>
    </div>
 * -----------------------------------------------------
 */

Cards.Card = _semanticUiReact.Card;
Cards.defaultProps = {
    count: false,
    showMore: false,
    cards: 4,
    empty: 'No Items'
};

exports.default = Cards;