'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Generate className from config
 * @param  {Object} 	  Styles    Hash Css Module Selector
 * @param  {Object} 	  Selectors Classs Config
 * @param  {String} 	  Selector  Main Class Selector
 * @param  {String|Array} Concat    Classes to Append
 * @return {String}           		className
 */
exports.default = function (Styles, Selectors, Selector, Concat) {
  return (0, _classnames2.default)(Object.keys(Selectors).filter(function (selector) {
    return Boolean(Selectors[selector]);
  }).map(function (selector) {
    return Styles[_lodash2.default.capitalize(selector)];
  }).concat(Styles[Selector]).concat(Concat));
};