'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

/**
 * Converts Number to Currency
 * @param  {Number}  n Number
 * @param  {String}  n Number
 * @param  {Boolean} s Sign
 * @param  {Number}  p Precision
 * @return {String}    Curreny
 */
exports.default = function () {
  var n = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
  var s = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var p = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 2;

  var sign = s ? n < 0 ? '-$' : '$' : '';
  var numb = s ? n < 0 ? -n : n : n;

  return sign + Number(numb).toFixed(p).replace(/(\d)(?=(\d\d\d)+(?!\d))/g, "$1,");
};