'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

require('../scripts/transition');

require('../scripts/dropdown');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  function Dropdown(props) {
    _classCallCheck(this, Dropdown);

    var _this = _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, props));

    _this.dropdown = _react2.default.createRef();
    return _this;
  }

  _createClass(Dropdown, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var on = {};

      if (this.props.onChange !== null) {
        on.onChange = this.props.onChange;
      }
      if (this.props.onAdd !== null) {
        on.onAdd = this.props.onAdd;
      }
      if (this.props.onRemove !== null) {
        on.onRemove = this.props.onRemove;
      }
      if (this.props.onLabelCreate !== null) {
        on.onLabelCreate = this.props.onLabelCreate;
      }
      if (this.props.onLabelRemove !== null) {
        on.onLabelRemove = this.props.onLabelRemove;
      }
      if (this.props.onLabelSelect !== null) {
        on.onLabelSelect = this.props.onLabelSelect;
      }
      if (this.props.onNoResults !== null) {
        on.onNoResults = this.props.onNoResults;
      }
      if (this.props.onShow !== null) {
        on.onShow = this.props.onShow;
      }
      if (this.props.onHide !== null) {
        on.onHide = this.props.onHide;
      }

      (0, _jquery2.default)(this.dropdown.current).dropdown(_extends({
        on: this.props.on,
        ignoreCase: this.props.ignoreCase,
        allowReselection: this.props.allowReselection,
        allowAdditions: this.props.allowAdditions,
        hideAdditions: this.props.hideAdditions,
        action: this.props.action,
        minCharacters: this.props.minCharacters,
        match: this.props.match,
        selectOnKeydown: this.props.selectOnKeydown,
        forceSelection: this.props.forceSelection,
        allowCategorySelection: this.props.allowCategorySelection,
        placeholder: this.props.placeholder,
        direction: this.props.direction,
        keepOnScreen: this.props.keepOnScreen,
        fullTextSearch: this.props.fullTextSearch,
        preserveHTML: this.props.preserveHTML,
        sortSelect: this.props.sortSelect,
        showOnFocus: this.props.showOnFocus,
        allowTab: this.props.allowTab,
        duration: this.props.duration
      }, on));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          name = _props.name,
          className = _props.className,
          icon = _props.icon,
          text = _props.text,
          type = _props.type;


      return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)("ui dropdown", className, type), ref: this.dropdown },
        _react2.default.createElement('input', { type: 'hidden', name: name }),
        _react2.default.createElement('i', { className: (0, _classnames2.default)('icon', icon) }),
        _react2.default.createElement(
          'div',
          { className: 'default text' },
          text
        ),
        _react2.default.createElement(
          'div',
          { className: 'menu' },
          children
        )
      );
    }
  }]);

  return Dropdown;
}(_react2.default.Component);

Dropdown.displayName = 'Dropdown';


Dropdown.defaultProps = {
  icon: "dropdown",
  text: "Select",
  type: "selection",
  on: "click",
  ignoreCase: false,
  allowReselection: false,
  allowAdditions: false,
  hideAdditions: true,
  action: "activate",
  minCharacters: 1,
  match: "both",
  selectOnKeydown: true,
  forceSelection: true,
  allowCategorySelection: false,
  placeholder: "auto",
  direction: 'auto',
  keepOnScreen: true,
  fullTextSearch: true,
  preserveHTML: true,
  sortSelect: false,
  showOnFocus: true,
  allowTab: true,
  duration: 200,
  onChange: null,
  onAdd: null,
  onRemove: null,
  onLabelCreate: null,
  onLabelRemove: null,
  onLabelSelect: null,
  onNoResults: null,
  onShow: null,
  onHide: null
};

Dropdown.Item = function (_ref) {
  var children = _ref.children,
      className = _ref.className,
      value = _ref.value;
  return _react2.default.createElement(
    'div',
    { className: (0, _classnames2.default)("item", className), 'data-value': value },
    children
  );
};

exports.default = Dropdown;