'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

require('../scripts/transition');

require('../scripts/dimmer');

require('../scripts/modal');

require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Modal = function (_React$Component) {
    _inherits(Modal, _React$Component);

    function Modal(props) {
        _classCallCheck(this, Modal);

        var _this = _possibleConstructorReturn(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).call(this, props));

        _this.modal = _react2.default.createRef();

        // Bindings
        _this.showModal = _this.showModal.bind(_this);
        _this.hideModal = _this.hideModal.bind(_this);
        return _this;
    }

    _createClass(Modal, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var settings = _extends({}, this.props.settings, {
                detachable: false
            });

            if (this.props.transition !== undefined) {
                settings.transition = this.props.transition;
            }

            if (this.props.onHide !== undefined) {
                settings.onHide = this.props.onHide;
            }

            if (this.props.onHidden !== undefined) {
                settings.onHidden = this.props.onHidden;
            }

            (0, _jquery2.default)(this.modal.current).modal(settings);
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.show !== this.props.show) {
                if (nextProps.show) {
                    this.showModal();
                } else {
                    this.hideModal();
                }
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            (0, _jquery2.default)('.ui.dimmer.modals').remove();
        }
    }, {
        key: 'showModal',
        value: function showModal() {
            (0, _jquery2.default)(this.modal.current).modal('show');
        }
    }, {
        key: 'hideModal',
        value: function hideModal() {
            (0, _jquery2.default)(this.modal.current).modal('hide');
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                children = _props.children,
                className = _props.className,
                button = _props.button,
                Trigger = _props.trigger,
                top = _props.top,
                size = _props.size;


            var Button = button !== undefined ? function () {
                return _react2.default.createElement(
                    'div',
                    { onClick: _this2.showModal, className: (0, _classnames2.default)('ui button', button.className, {
                            icon: button.icon !== undefined
                        }) },
                    _react2.default.createElement('i', { className: (0, _classnames2.default)('icon', button.icon) }),
                    button.text
                );
            } : null;

            return _react2.default.createElement(
                _react2.default.Fragment,
                null,
                Button && _react2.default.createElement(Button, null),
                Trigger && _react2.default.createElement(Trigger, { onClick: this.showModal }),
                _react2.default.createElement(
                    'div',
                    { className: (0, _classnames2.default)("ui modal et-module-modal", size, className, {
                            top: top
                        }), ref: this.modal },
                    children
                )
            );
        }
    }]);

    return Modal;
}(_react2.default.Component);

Modal.displayName = 'Modal';


Modal.Header = function (_ref) {
    var children = _ref.children,
        className = _ref.className;
    return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)("header", className) },
        children
    );
};

Modal.Content = function (_ref2) {
    var children = _ref2.children,
        className = _ref2.className;
    return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)("content", className) },
        children
    );
};

Modal.Actions = function (_ref3) {
    var children = _ref3.children,
        className = _ref3.className;
    return _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)("actions", className) },
        children
    );
};

Modal.defaultProps = {
    top: false,
    show: false,
    size: ''
};

exports.default = Modal;