'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

require('../scripts/transition');

require('../scripts/popup');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Popup = function (_React$Component) {
  _inherits(Popup, _React$Component);

  function Popup(props) {
    _classCallCheck(this, Popup);

    var _this = _possibleConstructorReturn(this, (Popup.__proto__ || Object.getPrototypeOf(Popup)).call(this, props));

    _this.popup = _react2.default.createRef();
    return _this;
  }

  _createClass(Popup, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      (0, _jquery2.default)(this.popup.current).popup({
        on: this.props.on,
        transition: this.props.transition,
        duration: this.props.duration,
        offset: this.props.offset,
        distanceAway: this.props.distanceAway,
        hideOnScroll: this.props.hideOnScroll,
        closable: this.props.closable,
        position: this.props.position,
        exclusive: this.props.exclusive
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          title = _props.title,
          content = _props.content;


      return _react2.default.createElement(
        'div',
        { 'data-title': title, 'data-content': content, ref: this.popup },
        children
      );
    }
  }]);

  return Popup;
}(_react2.default.Component);

Popup.displayName = 'Popup';


Popup.defaultProps = {
  on: 'hover',
  transition: 'slide down',
  duration: 200,
  offset: 0,
  distanceAway: 0,
  hideOnScroll: 'auto',
  closable: true,
  position: 'top left',
  exclusive: false
};

exports.default = Popup;