'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactHighlightWords = require('react-highlight-words');

var _reactHighlightWords2 = _interopRequireDefault(_reactHighlightWords);

var _semanticUiReact = require('semantic-ui-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Cell = function Cell(_ref) {
	var children = _ref.children,
	    className = _ref.className,
	    search = _ref.search,
	    props = _objectWithoutProperties(_ref, ['children', 'className', 'search']);

	return _react2.default.createElement(
		_semanticUiReact.Grid.Column,
		_extends({ className: (0, _classnames2.default)('et-cell', className) }, props),
		!_react2.default.isValidElement(children) && search.length > 0 ? _react2.default.createElement(_reactHighlightWords2.default, {
			searchWords: search.split(/\s/),
			textToHighlight: String(children) }) : children
	);
};

Cell.displayName = 'Cell';
Cell.defaultProps = {
	search: ''
};

exports.default = Cell;