'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Label = function Label(_ref) {
	var children = _ref.children,
	    show = _ref.show,
	    icon = _ref.icon,
	    onRemove = _ref.onRemove,
	    className = _ref.className,
	    props = _objectWithoutProperties(_ref, ['children', 'show', 'icon', 'onRemove', 'className']);

	return _react2.default.createElement(
		_semanticUiReact.Label,
		_extends({ className: (0, _classnames2.default)('et-label', className) }, props),
		icon && _react2.default.createElement(_semanticUiReact.Icon, { name: icon }),
		children,
		_react2.default.createElement(_semanticUiReact.Icon, { name: 'delete', onClick: onRemove })
	);
};

Label.displayName = 'Label';
Label.defaultProps = {
	size: 'large',
	as: 'a',
	icon: false
};

exports.default = Label;