'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Row = require('./Row');

var _Row2 = _interopRequireDefault(_Row);

var _Cell = require('../components/Cell');

var _Cell2 = _interopRequireDefault(_Cell);

var _semanticUiReact = require('semantic-ui-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Body = function Body(_ref) {
	var children = _ref.children,
	    none = _ref.none,
	    empty = _ref.empty,
	    loading = _ref.loading,
	    tight = _ref.tight,
	    className = _ref.className,
	    props = _objectWithoutProperties(_ref, ['children', 'none', 'empty', 'loading', 'tight', 'className']);

	return _react2.default.createElement(
		_semanticUiReact.Grid.Row,
		{ columns: 1 },
		_react2.default.createElement(
			_semanticUiReact.Dimmer,
			{ active: loading, inverted: true },
			_react2.default.createElement(_semanticUiReact.Loader, { active: loading, size: 'huge' })
		),
		_react2.default.createElement(
			_semanticUiReact.Grid.Column,
			_extends({ className: (0, _classnames2.default)('et-body', className, {
					'et-tight': tight,
					'et-loading': loading,
					'ui segments': tight
				}) }, props),
			!(_react2.default.Children.count(children) === 0 || none) ? children : _react2.default.createElement(
				_Row2.default,
				null,
				_react2.default.createElement(
					_Cell2.default,
					null,
					_react2.default.createElement(
						_semanticUiReact.Header,
						{ textAlign: 'center' },
						empty
					)
				)
			)
		)
	);
};

Body.displayName = 'Body';
Body.defaultProps = {
	empty: 'Table is Empty'
};

exports.default = Body;