'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Row = function Row(_ref) {
	var children = _ref.children,
	    inverted = _ref.inverted,
	    color = _ref.color,
	    cells = _ref.cells,
	    props = _objectWithoutProperties(_ref, ['children', 'inverted', 'color', 'cells']);

	return _react2.default.createElement(
		_semanticUiReact.Segment,
		{ className: 'et-row', color: color, inverted: inverted },
		_react2.default.createElement(
			_semanticUiReact.Grid,
			null,
			_react2.default.createElement(
				_semanticUiReact.Grid.Row,
				_extends({ columns: cells }, props),
				children
			)
		)
	);
};

Row.displayName = 'Row';
Row.defaultProps = {
	cells: 'equal'
};

exports.default = Row;