'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _semanticUiReact = require('semantic-ui-react');

var _Cell = require('./components/Cell');

var _Cell2 = _interopRequireDefault(_Cell);

var _Checkable = require('./components/Checkable');

var _Checkable2 = _interopRequireDefault(_Checkable);

var _Item = require('./components/Item');

var _Item2 = _interopRequireDefault(_Item);

var _Action = require('./components/Action');

var _Action2 = _interopRequireDefault(_Action);

var _Label = require('./components/Label');

var _Label2 = _interopRequireDefault(_Label);

var _Body = require('./containers/Body');

var _Body2 = _interopRequireDefault(_Body);

var _Footer = require('./containers/Footer');

var _Footer2 = _interopRequireDefault(_Footer);

var _Header = require('./containers/Header');

var _Header2 = _interopRequireDefault(_Header);

var _Items = require('./containers/Items');

var _Items2 = _interopRequireDefault(_Items);

var _Labels = require('./containers/Labels');

var _Labels2 = _interopRequireDefault(_Labels);

var _Actions = require('./containers/Actions');

var _Actions2 = _interopRequireDefault(_Actions);

var _Menu = require('./containers/Menu');

var _Menu2 = _interopRequireDefault(_Menu);

var _Row = require('./containers/Row');

var _Row2 = _interopRequireDefault(_Row);

require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

// Components


// Containers


// Styles


var Table = function Table(_ref) {
	var children = _ref.children,
	    className = _ref.className,
	    divided = _ref.divided,
	    hoverable = _ref.hoverable,
	    props = _objectWithoutProperties(_ref, ['children', 'className', 'divided', 'hoverable']);

	return _react2.default.createElement(
		_semanticUiReact.Grid,
		_extends({ className: (0, _classnames2.default)('et-module-table', className, {
				'et-divided': divided,
				'et-hoverable': hoverable
			}) }, props),
		children
	);
};

Table.displayName = 'Table';
// Components
Table.Cell = _Cell2.default;
Table.Checkable = _Checkable2.default;
Table.Item = _Item2.default;
Table.Action = _Action2.default;
Table.Label = _Label2.default;

// Containers
Table.Body = _Body2.default;
Table.Footer = _Footer2.default;
Table.Header = _Header2.default;
Table.Items = _Items2.default;
Table.Labels = _Labels2.default;
Table.Actions = _Actions2.default;
Table.Menu = _Menu2.default;
Table.Row = _Row2.default;

exports.default = Table;