import cx from 'classnames'
import React from 'react'
import FloatingActionButton from 'material-ui/FloatingActionButton'
import { Label } from 'semantic-ui-react'

const Item = ({ children, className, mini, color, light, bordered, label, as: Component, ...props }) => (
	<Component className={ cx('et-item', 'animated', {
		'et-mini': mini,
    'et-light': light,
    'et-bordered': bordered,
	}, className) } { ...props }>
		{ label &&  <Label color='black' className='et-label'>{ label }</Label>}
		<FloatingActionButton mini={ mini } backgroundColor={ color }>
			{ children }
		</FloatingActionButton>
	</Component>
)

Item.defaultProps = {
  as: 'div'
}

export default Item
