import PropTypes from 'prop-types'
import React from 'react'
import Tranistion from 'react-addons-css-transition-group'
import Durations from './styles'

const Animate = ({
	as,
	children,

	animate,
	transition,
	transitionTimeout,

	enter,
	transitionEnter,
	transitionEnterTimeout,

	leave,
	transitionLeave,
	transitionLeaveTimeout,

	...rest
}) => {
	if (transition !== null) {
		transitionEnter = transition
		transitionLeave = transition
	}

	if (transitionTimeout !== null) {
		transitionEnterTimeout = transitionTimeout
		transitionLeaveTimeout = transitionTimeout
	}

	if (animate !== null) {
		enter = animate
			.replace('InOut', 'In')
			.replace('OutIn', 'Out')
			.replace('DownUp', 'Down')
			.replace('UpDown', 'Up')
		leave = animate
			.replace('InOut', 'Out')
			.replace('OutIn', 'In')
			.replace('DownUp', 'Up')
			.replace('UpDown', 'Down')
	}

	const transitionName = {
		enter: Durations[`_${transitionEnterTimeout}`],
		leave: Durations[`_${transitionLeaveTimeout}`],
		enterActive: enter,
		leaveActive: leave
	}

	return (
		<Tranistion
		component={ as }
		transitionName={ transitionName }

		transitionEnter={ transitionEnter }
		transitionEnterTimeout={ transitionEnterTimeout }

		transitionLeave={ transitionLeave}
		transitionLeaveTimeout={ transitionLeaveTimeout }

		{ ...rest }>
			{ children }
		</Tranistion>
	)
}

Animate.defaultProps = {
	as: 'span',
	animate: null,
	transition: null,
	transitionTimeout: null,
	enter: 'fadeIn',
	transitionEnter: true,
	transitionEnterTimeout: 300,
	leave: 'fadeOut',
	transitionLeave: true,
	transitionLeaveTimeout: 300
}

Animate.propTypes = {
	enter: PropTypes.string,
	leave: PropTypes.string,
	duration: PropTypes.number,
	children: PropTypes.any
}

export default Animate
