import cx from 'classnames'
import lodash from 'lodash'

/**
 * Generate className from config
 * @param  {Object} 	  Styles    Hash Css Module Selector
 * @param  {Object} 	  Selectors Classs Config
 * @param  {String} 	  Selector  Main Class Selector
 * @param  {String|Array} Concat    Classes to Append
 * @return {String}           		className
 */
export default (Styles, Selectors, Selector, Concat) => cx(Object
	.keys(Selectors)
	.filter(selector => Boolean(Selectors[selector]))
	.map(selector => Styles[lodash.capitalize(selector)])
	.concat(Styles[Selector])
	.concat(Concat)
)
