/**
 * Converts Number to Currency
 * @param  {Number}  n Number
 * @param  {String}  n Number
 * @param  {Boolean} s Sign
 * @param  {Number}  p Precision
 * @return {String}    Curreny
 */
export default (n = 0, s = true, p = 2) => {
    const sign = s ? ( n < 0 ? '-$' : '$') : ''
    const numb = s ? ( n < 0 ? -n   : n  ) : n

    return sign + Number(numb).toFixed(p).replace(/(\d)(?=(\d\d\d)+(?!\d))/g, "$1,")
}
