export const format = number => {
  var formatedNumber = String(number).replace(/\D/g, '')

  var stage1 = formatedNumber.match(/^(\d{3})$/)
  var stage2 = formatedNumber.match(/^(\d{3})(\d{1,3})$/)
  var stage3 = formatedNumber.match(/^(\d{3})(\d{3})(\d{1,4})$/)

  if (stage3 !== null) {
    return "(" + stage3[1] + ") " + stage3[2] + "-" + stage3[3]
  } else if(stage2 !== null) {
    return "(" + stage2[1] + ") " + stage2[2]
  } else if (stage1 !== null) {
    return "(" + stage1[1] + ")"
  } else {
    return number
  }
}

export const parse = number => {
  return number
    .replace(/\((\d{3})$/, n => n.substr(1, n.length - 2))
    .replace(/[(|)|\-|\s]*/g, '')
  ;
}
