import React from 'react'
import cx from 'classnames'
import $ from 'jquery'

import '../scripts/transition'
import '../scripts/popup'

class Popup extends React.Component {
  constructor(props) {
      super(props)

      this.popup = React.createRef()
  }

  componentWillMount() {
    $(this.popup.current).popup({
      on: this.props.on,
      transition: this.props.transition,
      duration: this.props.duration,
      offset: this.props.offset,
      distanceAway: this.props.distanceAway,
      hideOnScroll: this.props.hideOnScroll,
      closable: this.props.closable,
      position: this.props.position,
      exclusive: this.props.exclusive
    })
  }

  render() {
    const {
      children,
      title,
      content
    } = this.props

    return (
      <div data-title={ title } data-content={ content } ref={ this.popup }>
        { children }
      </div>
    )
  }
}

Popup.defaultProps = {
  on: 'hover',
  transition: 'slide down',
  duration: 200,
  offset: 0,
  distanceAway: 0,
  hideOnScroll: 'auto',
  closable: true,
  position: 'top left',
  exclusive: false
}

export default Popup
