import cx from 'classnames'
import React from 'react'
import Highlighter from 'react-highlight-words'
import { Grid } from 'semantic-ui-react'

const Cell = ({ children, className, search, ...props }) => (
	<Grid.Column className={ cx('et-cell', className) } { ...props }>
	{
		(!React.isValidElement(children) && search.length > 0) ? (
			<Highlighter
			searchWords={ search.split(/\s/) }
			textToHighlight={ String(children) } />
		) : children
	}
	</Grid.Column>
)

Cell.defaultProps = {
	search: ''
}

export default Cell
