import cx from 'classnames'
import Checkbox from 'material-ui/Checkbox'
import MuiTheme from 'material-ui/styles/MuiThemeProvider'
import InterIcon from 'material-ui/svg-icons/toggle/indeterminate-check-box'
import React from 'react'
import Cell from './Cell'

export default ({ children, show, checked, intermediate, onCheck, ...props }) => (
	<Cell className={cx('et-checkable', {
		'et-show': show || checked
	})} { ...props }>
	{
		(show || checked) ? (
			<MuiTheme>
				<Checkbox
				checked={ checked }
				onCheck={ onCheck }
				uncheckedIcon={ intermediate ? (<InterIcon />) : null }
				/>
			</MuiTheme>
		) : children
	}
	</Cell>
)
