import cx from 'classnames'
import React from 'react'
import { Label as SUILabel, Icon } from 'semantic-ui-react'

const Label = ({ children, show, icon, onRemove, className, ...props }) => (
	<SUILabel className={cx('et-label', className)} { ...props }>
		{ icon && <Icon name={ icon } /> }
		{ children }
		<Icon name='delete' onClick={ onRemove } />
	</SUILabel>
)

Label.defaultProps = {
	size: 'large',
	as: 'a',
	icon: false
}

export default Label
