import cx from 'classnames'
import MuiTheme from 'material-ui/styles/MuiThemeProvider'
import Animate from 'animate'
import React from 'react'
import { Menu } from 'semantic-ui-react'

const Actions = ({ children, position, show, fluid, animate, className, ...props }) => (
    <Animate className={cx('et-actions-container', {
        'et-show': show
    })} animate={ animate } { ...props }>
    {
        show && (
            <MuiTheme>
                <Menu secondary>
                    <Menu.Menu className={cx('et-actions', className)}  position={ position }>
                        { children }
                    </Menu.Menu>
                </Menu>
            </MuiTheme>
        )
    }
    </Animate>
)

Actions.defaultProps = {
    position: 'right',
    animate: 'fadeInOut'
}

export default Actions
