import cx from 'classnames'
import React from 'react'
import Row from './Row'
import Cell from '../components/Cell'

import {
	Grid,
	Header,
	Dimmer,
	Loader
} from 'semantic-ui-react'

const Body = ({ children, none, empty, loading, tight, className, ...props }) => (
	<Grid.Row columns={1}>
		<Dimmer active={ loading } inverted>
			<Loader active={ loading } size='huge'/>
		</Dimmer>
		<Grid.Column className={cx('et-body', className, {
				'et-tight': tight,
				'et-loading': loading,
				'ui segments': tight
		})} { ...props }>
		{
			!(React.Children.count(children) === 0 || none) ? children : (
				<Row>
					<Cell>
						<Header textAlign='center'>{ empty }</Header>
					</Cell>
				</Row>
			)
		}
		</Grid.Column>
	</Grid.Row>
)

Body.defaultProps = {
	empty: 'Table is Empty'
}

export default Body
