import React from 'react'
import { Grid, Segment } from 'semantic-ui-react'

const Row = ({ children, inverted, color, cells, ...props }) => (
	<Segment className='et-row' color={ color } inverted={ inverted }>
		<Grid>
			<Grid.Row columns={ cells } { ...props }>
				{ children }
			</Grid.Row>
		</Grid>
	</Segment>
)

Row.defaultProps = {
	cells: 'equal'
}

export default Row
