import cx from 'classnames'
import React from 'react'
import { Grid } from 'semantic-ui-react'

// Components
import Cell from './components/Cell'
import Checkable from './components/Checkable'
import Item from './components/Item'
import Action from './components/Action'
import Label from './components/Label'

// Containers
import Body from './containers/Body'
import Footer from './containers/Footer'
import Header from './containers/Header'
import Items from './containers/Items'
import Labels from './containers/Labels'
import Actions from './containers/Actions'
import Menu from './containers/Menu'
import Row from './containers/Row'

// Styles
import './styles'

const Table = ({ children, className, divided, hoverable, ...props }) => (
	<Grid className={cx('et-module-table', className, {
		'et-divided': divided,
		'et-hoverable': hoverable
	})} { ...props }>
		{ children }
	</Grid>
)

// Components
Table.Cell = Cell
Table.Checkable = Checkable
Table.Item = Item
Table.Action = Action
Table.Label = Label

// Containers
Table.Body = Body
Table.Footer = Footer
Table.Header = Header
Table.Items = Items
Table.Labels = Labels
Table.Actions = Actions
Table.Menu = Menu
Table.Row = Row

export default Table
