# Example Table

```html
import React from 'react'
import Table from 'table'
import Search from 'search'

import {
    Button,
    Icon
} from 'semantic-ui-react'

export default () => (
    <Table divided>
        <Table.Menu>
            <Table.Labels></Table.Labels>
            <Table.Items>
                <Table.Item>
                    <Search />
                </Table.Item>
                <Table.Item>
                    <Button color='brown' circular icon>
                        <Icon name='circle' />
                    </Button>
                </Table.Item>
                <Table.Item>
                    <Button color='green' circular icon>
                        <Icon name='star' />
                    </Button>
                </Table.Item>
                <Table.Item>
                    <Button color='yellow' circular icon>
                        <Icon name='square' />
                    </Button>
                </Table.Item>
                <Table.Item>
                    <Button color='blue' circular icon>
                        <Icon name='block layout' />
                    </Button>
                </Table.Item>
            </Table.Items>
        </Table.Menu>
        <Table.Header>
            <Table.Row>
                <Table.Cell>ID</Table.Cell>
                <Table.Cell>SKU</Table.Cell>
                <Table.Cell>Company</Table.Cell>
                <Table.Cell>Description</Table.Cell>
                <Table.Cell>Price</Table.Cell>
                <Table.Cell>Stock</Table.Cell>
                <Table.Cell>Display</Table.Cell>
                <Table.Cell>Rating</Table.Cell>
            </Table.Row>
        </Table.Header>
        <Table.Body empty='Product Not Found'></Table.Body>
        <Table.Footer>
            <Button color='green' floated='right' size='large' circular icon>
                <Icon name='plus' />
            </Button>
        </Table.Footer>
    </Table>
)
```
